Option Compare Binary
Option Explicit On 
Option Strict On

Public Class CDrone
    Inherits CBee

    Public Sub New(ByVal ptHive As PointF, ByVal ptBee As PointF, ByVal intHiveID As Integer, Optional ByVal blnOutside As Boolean = False)
        MyBase.New(ptHive, ptBee, intHiveID, blnOutside)
    End Sub

    Public Overrides Sub Tick()
        MyBase.Tick()
        ' Drones are forcibly evicted from the hive come autumn.
        ' To be on the safe side, I'm including winter here too.
        ' TODO: Move this into guard worker bee behaviour, rather than having suicidal drones.
        Select Case CDome.Season
            Case ESeason.ssnAutumn, ESeason.ssnWinter
                Die()
        End Select
    End Sub

    Public Overrides ReadOnly Property Caste() As ECaste
        Get
            Return ECaste.cstDrone
        End Get
    End Property

    Public Overrides ReadOnly Property LifeExpectancy() As Integer
        Get
            ' 6 months.
            ' In practice, drones all starve to death in autumn,
            ' so I don't know how long they could theoretically live.
            Return 200
        End Get
    End Property

    Private Sub Mate()

        ' The drone dies, the queen is fine.
        Die()

    End Sub

    Protected Overrides Sub Search()

        ' TODO: Look for a mating point.

    End Sub

    Protected Overrides Sub ReachTarget()

        ' TODO: Wait for a queen to turn up.

    End Sub

End Class
