Option Compare Binary
Option Explicit On 
Option Strict On

Public MustInherit Class CFemale
    Inherits CBee

    ' Has this female bee mated?
    ' (Workers never will, queens usually will.)
    Protected mblnHasMated As Boolean = False

    ' Lay an egg in this cell.
    Public Sub LayEgg(ByVal celThis As CCell)
        ' This stores the egg's caste.
        Dim cstEgg As ECaste

        ' See whether this female has mated.
        If mblnHasMated Then

            ' If so, the egg could be fertilised or unfertilised.
            ' TODO: Include factors in this choice, such as the time of year and the type of cell.
            ' Also, allow for new queens to be born.
            Dim blnFemaleEgg As Boolean = (Rnd() < 0.5)
            If blnFemaleEgg Then
                cstEgg = ECaste.cstWorker
            Else
                cstEgg = ECaste.cstDrone
            End If

        Else

            ' If not, the egg won't be fertilised, so it has to be a drone.
            cstEgg = ECaste.cstDrone

        End If  ' end "has the mother mated?" if statement.

        ' Lay the appropriate egg.
        celThis.LayEgg(cstEgg)

    End Sub

    ' In theory a bee could sting anything,
    ' but in our current simulation it will only ever be another bee.
    Public Sub Sting(ByVal beeTarget As CBee)

    End Sub

    Public Sub New(ByVal ptHive As PointF, ByVal ptBee As PointF, ByVal intHiveID As Integer, Optional ByVal blnOutside As Boolean = False)
        MyBase.New(ptHive, ptBee, intHiveID, blnOutside)
    End Sub

End Class
