Option Compare Binary
Option Explicit On 
Option Strict On

Public Class CQueen
    Inherits CFemale

    Public Sub New(ByVal ptHive As PointF, ByVal ptBee As PointF, ByVal intHiveID As Integer, Optional ByVal blnOutside As Boolean = False)
        MyBase.New(ptHive, ptBee, intHiveID, blnOutside)
        mdblDirection = 0
        mblnHasMated = True
    End Sub

    Public Overrides Sub Tick()
        MyBase.Tick()
        If (Rnd() < 0.1) Then
            Dim celFree As CCell
            If GetFreeCell(celFree) Then
                LayEgg(celFree)
            End If
        End If
    End Sub

    Public Overrides ReadOnly Property Caste() As ECaste
        Get
            Return ECaste.cstQueen
        End Get
    End Property

    Public Overrides ReadOnly Property LifeExpectancy() As Integer
        Get
            ' Five years.
            Return 1825
        End Get
    End Property

    Protected Overrides Sub Search()

        ' TODO: Look for a mating point.

    End Sub

    Protected Overrides Sub ReachTarget()

        ' TODO: Mate.

    End Sub

    Private Function GetFreeCell(ByRef celFree As CCell) As Boolean
        ' This stores the function's return value.
        Dim blnReturnValue As Boolean = False
        ' This accesses the relevant comb.
        Dim cmbThis As CComb
        ' This is used to loop through the list of cells.
        Dim intThisCell As Integer
        ' This accesses each cell in turn.
        Dim celThis As CCell

        ' Access the comb that the queen is on.
        cmbThis = CDome.GetHive(mintHiveID).Combs(mintComb)

        ' Look for a free cell, and stop if we find one.
        intThisCell = 0
        Do While (intThisCell < cmbThis.CellCount) And Not blnReturnValue
            celThis = cmbThis.Cells(intThisCell)
            If (celThis.Contents = ECellContents.ccEmpty) Then
                celFree = celThis
                blnReturnValue = True
            Else
                intThisCell += 1
            End If
            celThis = Nothing
        Loop

        ' Return the appropriate result from this function.
        Return blnReturnValue

    End Function

End Class
