Public Class FCalibrate
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblTimeWarp As System.Windows.Forms.Label
    Friend WithEvents udTimeWarp As System.Windows.Forms.NumericUpDown
    Friend WithEvents lblExamples As System.Windows.Forms.Label
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lblTimeWarp = New System.Windows.Forms.Label
        Me.udTimeWarp = New System.Windows.Forms.NumericUpDown
        Me.lblExamples = New System.Windows.Forms.Label
        Me.btnOK = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        CType(Me.udTimeWarp, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'lblTimeWarp
        '
        Me.lblTimeWarp.Location = New System.Drawing.Point(16, 16)
        Me.lblTimeWarp.Name = "lblTimeWarp"
        Me.lblTimeWarp.Size = New System.Drawing.Size(96, 16)
        Me.lblTimeWarp.TabIndex = 0
        Me.lblTimeWarp.Text = "Time warp factor:"
        '
        'udTimeWarp
        '
        Me.udTimeWarp.Location = New System.Drawing.Point(128, 16)
        Me.udTimeWarp.Maximum = New Decimal(New Integer() {10000, 0, 0, 0})
        Me.udTimeWarp.Name = "udTimeWarp"
        Me.udTimeWarp.Size = New System.Drawing.Size(72, 20)
        Me.udTimeWarp.TabIndex = 1
        Me.udTimeWarp.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'lblExamples
        '
        Me.lblExamples.Location = New System.Drawing.Point(16, 56)
        Me.lblExamples.Name = "lblExamples"
        Me.lblExamples.Size = New System.Drawing.Size(272, 72)
        Me.lblExamples.TabIndex = 2
        Me.lblExamples.Text = "0.5 = half real-time, 1 = real-time, 2 = double real-time, 365 = 1 year per day, " & _
        "8760 = 1 year per hour"
        '
        'btnOK
        '
        Me.btnOK.Location = New System.Drawing.Point(48, 144)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.TabIndex = 3
        Me.btnOK.Text = "OK"
        '
        'btnCancel
        '
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.Location = New System.Drawing.Point(176, 144)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.TabIndex = 4
        Me.btnCancel.Text = "Cancel"
        '
        'FCalibrate
        '
        Me.AcceptButton = Me.btnOK
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(298, 183)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.lblExamples)
        Me.Controls.Add(Me.udTimeWarp)
        Me.Controls.Add(Me.lblTimeWarp)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "FCalibrate"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Calibrate"
        CType(Me.udTimeWarp, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The time-warp factor.
    Private msngTimeWarpFactor As Single

    Public ReadOnly Property TimeWarpFactor() As Single
        Get
            Return msngTimeWarpFactor
        End Get
    End Property

    Private Sub FCalibrate_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Display the example factors.
        ' N.B. We need to do this here (rather than in the editor),
        ' so that we can insert new-line characters where needed.
        lblExamples.Text = "0.5 = half real-time" & ControlChars.NewLine & _
                            "1 = real-time" & ControlChars.NewLine & _
                            "2 = double real-time" & ControlChars.NewLine & _
                            "365 = 1 year per day" & ControlChars.NewLine & _
                            "8760 = 1 year per hour"

    End Sub

    ' This function checks whether the user entered valid information.
    ' If so, the function returns True; it returns False otherwise.
    ' The sole criterion is that the user has to enter a positive value.
    ' Barring an extreme case (e.g. 1 nanosecond per day), this should be fine.
    Private Function InformationOK() As Boolean
        ' This stores the function's return value.
        Dim blnReturnValue As Boolean = False

        ' See whether the user entered anything at all.
        If (udTimeWarp.Text.Length = 0) Then

            ' If not, object.
            MessageBox.Show("You need to enter a time-warp factor.", "Calibration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            ' If so, see whether it is positive.
        ElseIf (udTimeWarp.Value <= 0) Then

            ' If not, object.
            MessageBox.Show("You need to enter a positive time-warp factor - time can't run backwards!", "Calibration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        Else

            ' If so, this is fine, so set the return value to True.
            blnReturnValue = True

        End If  ' end "valid information?" if statement.

        ' Return the appropriate result from this function.
        Return blnReturnValue

    End Function

    Private Sub btnOK_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnOK.Click

        ' Check whether the user entered valid information.
        If InformationOK() Then

            ' If so, store it.
            msngTimeWarpFactor = udTimeWarp.Value

            ' Set the dialog result to OK (this will automatically close the dialog).
            Me.DialogResult = DialogResult.OK

        End If  ' end "information ok?" if statement.

    End Sub

End Class
